IFNDEF __COMMON

	__COMMON	EQU <COMMON_LIBRARY>

rgba		macro r:req,g:req,b:req,a:=<0>
		exitm <((a shl 24) or (r shl 16) or (g shl 8) or b)>
endm

@isfloat	macro string
		LOCAL res
		res textequ <0>
		forc char,<string>
			ifidn <char>,<!.>
				res textequ <1>
			endif
		endm
		exitm res
endm

finvoke		macro arglist:vararg
LOCAL arg,arglist2,count
		count = 0
		arglist2 textequ <>
		for arg,<arglist>
			if count EQ 0
				arglist2 catstr <arg>
			elseif count EQ 1
				ifdifi <arg>,<eax>
					mov	eax,arg
				endif
			elseif count EQ 2
				ifdifi <arg>,<ecx>
					mov	ecx,arg
				endif
			elseif count EQ 3
				ifdifi <arg>,<edx>
					mov	edx,arg
				endif
			else
				arglist2 catstr arglist2,<!,>,<arg>
			endif
			count = count + 1
		endm
		%invoke arglist2
endm

invoke2		macro func,args:vararg
		LOCAL count,arg,revargs,char
		ifb <args>
			%invoke func
		else
			count = 0
			revargs textequ <>
			for arg,<args>
				revargs catstr <arg>,<,>,revargs
				count = count + 4
			endm
			arg textequ <>
			%forc char,<revargs>
				ifdif <char>,<,>
					arg catstr arg,<char>
				else
					ifidn @isfloat(%arg),<1>
						pushfl arg
					else
						push arg
					endif
					arg textequ <>
				endif
			endm
			call func
		endif
endm

ucmpf		macro arg1,arg2
        	cmp	arg1,12345678h
        	org $-4
        	real4 arg2
endm

cmpf		macro arg1,arg2
        	cmp	arg1,12345678h
        	org $-4
        	real4 arg2
endm

fildc		macro arg1
        	mov	[esp-4],arg1
        	fild	dword ptr [esp-4]
endm

fldc		macro arg1
        	mov	dword ptr [esp-4],12345678h
        	org $-4
        	real4 arg1
        	fld	real4 ptr [esp-4]
endm

movf		macro arg1,arg2
        	mov	arg1,12345678h
        	org $-4
        	real4 arg2
endm

pushfl		macro arg1
        	push	12345678h
        	org $-4
        	real4 arg1
endm		

;==============================
; METHODS

;================================================================
; void DWtoA(dwNumber,lpStr,dwBase) - Convert number into string
;
; Parameters
;	dwNumber	dword value
;	lpStr		pointer to destination string
;	dwBase		desired base of the number representation
;
; Returns
;	ecx		length of string
;
;================================================================
	DWtoA	PROTO dwNumber:DWORD,lpStr:DWORD,dwBase:DWORD


;================================================================
; int AtoDW(lpStr,dwBase) - Convert string into number
;
; Parameters
;	lpStr		pointer to string holding the number
;	dwBase		desired base of the number representation
;
; Returns
;	Zero on success, non-zero on failure
;
;================================================================
	AtoDW	PROTO lpStr:DWORD,dwBase:DWORD

;================================================================
; void R4toA(lpFloat,lpStr,dwFormat) - Convert REAL4 number into decimal string
;
; Parameters
;	lpFloat		pointer to REAL4 number
;	lpStr		pointer to destination string
;	dwLength	length of buffer pointed by lpStr
;
; Returns
;	eax		length of output string
;
;================================================================
	R4toA	PROTO lpFloat:DWORD,lpStr:DWORD,dwLength:DWORD

;================================================================
; void R8toA(lpFloat,lpStr,dwFormat) - Convert REAL8 number into decimal string
;
; Parameters
;	lpFloat		pointer to REAL8 number
;	lpStr		pointer to destination string
;	dwLength	length of buffer pointed by lpStr
;
; Returns
;	eax		length of output string
;
;================================================================
	R8toA	PROTO lpFloat:DWORD,lpStr:DWORD,dwLength:DWORD

;================================================================
; int AtoR4(lpStr,lpFloat) - Convert decimal string into REAL4 number
;
; Parameters
;	lpStr		pointer to string holding the number
;	lpFloat		pointer to destination REAL4 number
;
; Returns
;	Zero on success, non-zero on failure
;
;================================================================
	AtoR4	PROTO lpStr:DWORD,lpFloat:DWORD

;================================================================
; int AtoR8(lpStr,lpFloat) - Convert decimal string into REAL8 number
;
; Parameters
;	lpStr		pointer to string holding the number
;	lpFloat		pointer to destination REAL8 number
;
; Returns
;	Zero on success, non-zero on failure
;
;================================================================
	AtoR8	PROTO lpStr:DWORD,lpFloat:DWORD

ENDIF