; 
; FLT osztly
; 

.data
	fsqrt2		real4 1.4142135623730950488016887242097
	fPIpSMPRATE	real4 0.0

	assume ecx:ptr FLT
.code
FLT_constructor		proc
			push	ecx
			;push	dword ptr size FLTDATA
			;push	dword ptr GPTR
			;call lpGlobalAlloc_
			invoke lpGlobalAlloc_,GPTR,FLTDATA
			pop	ecx
			mov	[ecx].lpFilterData,eax
			mov	[eax+FLTDATA.dwOrder],2
			mov	[eax+FLTDATA.lpCalculation],offset FLT_Butterworth2pole
			mov	[ecx].Run,offset FLT_run
			fldpi
			fdiv	ssn_variables.fMixingFrequency
			fstp	fPIpSMPRATE
			ret
FLT_constructor		endp

FLT_Butterworth2pole	proc
;	z = tan(pi*coff[k]/smpRate)
;	c[0] = c[2] = 1; c[1] = -2;
;	b[0] = b[2] = z^2; b[1] = 2*b[0];
;	p = sqrt(2)/reso[k]*z;
;	a[0] = b[0]+1+p; a[1] = b[1]-1; a[2] = b[0]+1-p;

; z=tan(coff*PI/sampleRate);
; b0=z^2/a0;
; b1=2*b0;
; b2=b0;
; a0=z^2+ z*reso + 1.0;
; a1=2*(z^2 - 1.0);
; a2=z^2 - z*reso + 1.0;
			assume esi:ptr FLTDATA
			mov	edx,[ecx].fCutoff
			fld	real4 ptr [edx+ebx*4]
		; coff
			fmul	fPIpSMPRATE
			fptan
		; 1, z
			fld	st(1)
		; z, 1, z
			fst	[esi].z
			fmul	st,st
			fst	[esi+0*4].bi		; b0
			fst	[esi+2*4].bi		; b2
			fld	st
		; z^2, z^2, 1, z
			fadd	st,st
			fstp	[esi+1*4].bi		; b1
		; z^2, 1, z
			mov	edx,[ecx].fResonance
			fld	fsqrt2
		; sqrt(2), z^2, 1.0, z
			fld1
			fsub	real4 ptr [edx+ebx*4]
			fmulp	st(1),st
			fmulp	st(3),st
		; z^2, 1, p
			fld	st
		; z^2, z^2, 1, p
			fsub	st,st(2)
			fadd	st,st
			fstp	[esi+1*4].ai		; a1
		; z^2, 1, p
			faddp	st(1),st
		; z^2+1, p
			fld	st
		; z^2+1, z^2+1, p
			fadd	st,st(2)
			fstp	[esi+0*4].ai		; a0
		; z^2+1, p
			fsubrp	st(1),st
		; z^2+1-p
			fstp	[esi+2*4].ai		; a2
;			fld1
;			fst	[esi+0*4].ci		; c0
;			fst	[esi+2*4].ci		; c2
;			fadd	st,st
;			fchs
;			fstp	[esi+1*4].ci		; c1
			ret
			assume esi:nothing
FLT_Butterworth2pole	endp

FLT_run			proc
; smp[0] = smp[frameSize];
; for (k=1; k<frameSize+1; i++)
; {
; 	; egytthatk szmtsa
;	lp = b[0]*u[k];
;	hp = c[0]*u[k];
; ; konvolci
;	for (j=r; j>0; j--)
;	{
;		if (k < j)
;		{
;			lp[k] += b[j]*ui[j] - ai[j]*lp[j];
;			hp[k] += c[j]*ui[j] - ai[j]*hp[j];
;		} else
;		{
;			lp[k] += b[j]*in1[k-j] - ai[j]*out1[k-j];
;			hp[k] += c[j]*in1[k-j] - ai[j]*out2[k-j];
;		}
;	}
;	lp[k] /= ai[0];
;	hp[k] /= ai[0];
; }
			call MDL_prepareRun
			push	ebp
			mov	esi,[ecx].lpFilterData
			assume esi:ptr FLTDATA
			mov	ebp,[ecx].out2		; hp
		@loop:
			inc	ebx
			call dword ptr [esi].lpCalculation
			mov	edx,[ecx].in1		; u[k]
			fld	real4 ptr [edx+ebx*4]
			fld	st
			fmul	[esi].bi		; lp, u[k]
			mov	edx,[esi].dwOrder
		@convolve:
			mov	eax,ebx
			push	ebx
			mov	ebx,[ecx].in1		; u[k]
			mov	edi,[ecx].out1		; lp[k]
			sub	eax,edx			; k-j
			jnc @f
				lea	ebx,[esi].ui	; u[k]
				lea	edi,[esi].lp	; lp[k]
				not	eax
		@@:
			fld	real4 ptr [ebx+eax*4]	; u[k-j], lp, u[k]
			fmul	[esi+edx*4].bi
			faddp	st(1),st		; lp+b[j]*u[k-j], u[k]
			fld	[esi+edx*4].ai		; a[j], lp+b[j]*u[k-j], u[k]
			fmul	real4 ptr [edi+eax*4] 
			fsubp	st(1),st		; lp+b[j]*u[k-j]-a[j]*lp[k-j], u[k]
			pop	ebx
			dec	edx
			jnz @convolve
			fdiv	[esi].ai
			fst	real4 ptr [edi+ebx*4]	; lp[k], u[k]
			fsubp	st(1),st		; hp[k] = u[k]-lp[k]
			fstp	real4 ptr [ebp+ebx*4]
		@next:
			cmp	ebx,FRAME_SIZE
			jc @loop

	; for (j=1-r; j<0; j++)
	; {
	;	lp[r-1-j] = out1[FRAME_SIZE+j];
	;	ui[r-1-j] = in1[FRAME_SIZE+j];
	; }
			xor	ebx,ebx
			mov	edx,[esi].dwOrder	; r
			mov	ebp,[ecx].in1
			dec	edx			; r-1
			sub	ebx,edx			; 1-r
			add	edi,FRAME_SIZE_IN_BYTES
			lea	esi,[esi+edx*4]
		@@:
			mov	eax,[edi+ebx*4]
			mov	edx,[ebp+ebx*4]
			mov	[esi+ebx*4].lp,eax
			mov	[esi+ebx*4].ui,eax
			inc	ebx
			jnz @b

			pop	ebp
			ret
			assume esi:nothing
FLT_run			endp

;FLT_run		proc
;; smp[0] = smp[frameSize];
;; for (k=1; k<frameSize+1; i++)
;; {
;; egytthatk szmtsa
;;	z = tan(pi*coff[k]/smpRate)
;;	c0 = c2 = 1; c1 = -2;
;;	b0 = b2 = z^2; b1 = 2*z^2;
;;	p = sqrt(2)/reso[k]*z;
;;	a0 = b0+1+p; a1 = 2*b0-1; a2 = b0+1-p;
;;
;;	lp = hp = b[0]*u[k];
;;	hp = b[0]*u[k];
;;	for (j=1; j<r; j++)
;;	{
;;		if (j > k)
;;		{
;;			lp += ui[k-j]*b[j] - ai[k-j]*y[];
;;			hp += ui[k-j]*b[j] - ci[k-j]*y[];
;;		} else
;;		{
;;		}
;;	}
;; }
;
;; y[k] = b0*u[k] + b1*u[k-1] + b2*u[k-2] + ... + bm*u[k-m] - a1*y[k-1] - a2*y[k-2] - ... - an*y[k-n]
;
;			call MDL_prepareRun
;		@loop:
;			mov	edx,[ecx].fCutoff
;			mov	eax,[edx+ebx*4]			; coff[k]
;			cmp	eax,[edx-4]			; coff[k] <> coff[k-1]
;			jnz @reso
;		@reso:
;			mov	edx,[ecx].fResonance
;			mov	eax,[edx+ebx*4]			; reso[k]
;			cmp	eax,[edx-4]			; reso[k] <> reso[k-1]
;			jnz @1
;
;
;		@1:
;			mov	esi,[ecx].lpFilterData
;			mov	edx,[esi]			; filter rang
;
;
;			inc	ebx
;			cmp	ebx,FRAME_SIZE
;			jc @loop
;			ret
;FLT_run			endp 
	assume ecx:nothing