; 
; OSC osztly
; 

	include masm32.inc
	includelib masm32.lib

.code
	OscRunProcs	dd OSC_runIMP, OSC_runSAW, OSC_runSIN, OSC_runRND
			dd OSC_runPULSE, OSC_runPSAW, OSC_runTRI

	assume ecx:ptr OSC

OSC_BEGIN	macro
		push	ebp
		call MDL_prepareRun
		mov	ebp,offset ssn_variables.fMixingFrequency
	@loop:
		call MDL_slope
		and	[ecx].fCounter,edx
endm

OSC_END		macro
	@@:
		fstp	[ecx].fCounter
		cmp	ebx,FRAME_SIZE
		jc @loop
		pop	ebp
endm

OSC_constructor		proc ; eax:dwCode
			and	eax,0fh
;			cmp	al,OSC_TYPE_LAST_CODE 
;			jna @F
;				mov	ebx,01h			; default = saw
;		@@:
			mov	edx,[OscRunProcs+eax*4]
			mov	[ecx].Run,edx
			ret
OSC_constructor		endp
;align 4
OSC_runIMP		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	smp[i] = (counter < fre[i]) ? amp[i] : -amp[i];
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }
			OSC_BEGIN
			mov	edx,[ecx].fre
			mov	esi,[ecx].amp
			mov	eax,[edx+ebx*4]		; fre[i]
			fld	real4 ptr [esi+ebx*4]	; amp[i]
			cmp	eax,[ecx].fCounter
			jnc @f
				fchs
		@@:
			fstp	real4 ptr [edi+ebx*4]
			fld	[ecx].fCounter
			mov	eax,real4 ptr [ebp]
			fadd	real4 ptr [edx+ebx*4]
			fst	[ecx].fCounter
			cmp	[ecx].fCounter,eax
			jc @f
				fsub	real4 ptr [ebp]
			OSC_END
			ret
OSC_runIMP		endp

OSC_runSAW		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	smp = 2*amp*counter/sampleRate-amp
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }

;			call MDL_prepareRun
;		@loop:
;			call MDL_slope
;			and	[ecx].fCounter,edx
			OSC_BEGIN
			fld	[ecx].fCounter		; counter
			fld	st
			fadd	st,st			; 2*counter
			mov	esi,[ecx].amp
			fmul	real4 ptr [esi+ebx*4]	; counter*2*amp
			fdiv	real4 ptr [ebp]
			fsub	real4 ptr [esi+ebx*4]	; counter*2*amp/sampleRate-amp
			fstp	real4 ptr [edi+ebx*4]
			mov	esi,[ecx].fre
			fadd	real4 ptr [esi+ebx*4]
			fst	[ecx].fCounter
			mov	eax,[ebp]
			cmp	[ecx].fCounter,eax
			jc @f
				fsub	real4 ptr [ebp]
		@@:
			OSC_END
			ret
OSC_runSAW		endp

OSC_runSIN		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	smp = amp*sin(2*PI*counter/sampleRate)
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }
;LOCAL dwPSW:dword
			push	ebp
			lea	ebp,ssn_variables.fMixingFrequency
			fldpi
			mov	ebp,offset ssn_variables.fMixingFrequency
			fadd	st,st
			fdiv	real4 ptr [ebp]
			call MDL_prepareRun
	@loop:
			call MDL_slope
			and	[ecx].fCounter,edx
			fld	st
			fmul	[ecx].fCounter
			fsin				; sin(2*PI*counter/sampleRate)
			mov	esi,[ecx].amp
			fmul	real4 ptr [esi+ebx*4]	; amp*smp
			fstp	real4 ptr [edi+ebx*4]
			fld	[ecx].fCounter
			mov	esi,[ecx].fre
			fadd	real4 ptr [esi+ebx*4]
			fst	[ecx].fCounter
			mov	eax,[ebp]
			cmp	[ecx].fCounter,eax
			jc @f
				fsub	real4 ptr [ebp]
		@@:
			OSC_END
			fstp	st
			ret
OSC_runSIN		endp

OSC_runRND		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	smp = amp*rnd
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }
			OSC_BEGIN
			fld	[ecx].fCounter		; counter
			mov	esi,[ecx].amp
			fld	[ecx].fValue1
			fmul	real4 ptr [esi+ebx*4]	; amp*rnd
			fstp	real4 ptr [edi+ebx*4]
			mov	esi,[ecx].fre
			fadd	real4 ptr [esi+ebx*4]
			fadd	real4 ptr [esi+ebx*4]
			fst	[ecx].fCounter
			mov	eax,[ebp]
			cmp	[ecx].fCounter,eax
			jc @f
				fsub	real4 ptr [ebp]
				push	ecx
				push	dword ptr 00fffffffh
				fild	dword ptr [esp]
				call nrandom
				shl	eax,1
				mov	[esp-4],eax
				fidivr	dword ptr [esp-4]
				fld1
				fsubp	st(1),st
				pop	ecx
				fstp	[ecx].fValue1
		@@:
			OSC_END
			ret
OSC_runRND		endp

OSC_runPULSE		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	smp = (counter < psw[i]*sampleRate) ? amp : -amp
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }
LOCAL fPSW:real4
			OSC_BEGIN
				mov	esi,[ecx].psw
				fld	real4 ptr [esi+ebx*4]
				fmul	real4 ptr [ebp]
				fstp	fPSW
				mov	esi,[ecx].amp
				fld	real4 ptr [esi+ebx*4]	; amp
				mov	eax,[ecx].fCounter
			cmp	eax,fPSW
			jc @f
				fchs
		@@:
			fstp	real4 ptr [edi+ebx*4]
			fld	[ecx].fCounter		; counter
			mov	esi,[ecx].fre
			fadd	real4 ptr [esi+ebx*4]
			fst	[ecx].fCounter
			mov	eax,[ebp]
			cmp	[ecx].fCounter,eax
			jc @f
				fsub	real4 ptr [ebp]
		@@:
			OSC_END
			ret
OSC_runPULSE		endp

OSC_runPSAW		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	PSW = psw[i]*sampleRate;
;	smp = (counter < PSW) ? 2*amp*counter/PSW-amp : -amp
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }
LOCAL fPSW:real4
			OSC_BEGIN
			fld	[ecx].fCounter		; counter
				mov	esi,[ecx].psw
				fld	real4 ptr [esi+ebx*4]	; psw
				fmul	real4 ptr [ebp]
				fstp	fPSW
				mov	esi,[ecx].amp
				fld	real4 ptr [esi+ebx*4]	; amp
				mov	eax,[ecx].fCounter
			cmp	eax,fPSW
			jnc @f
				fld	st(1)		; counter
				fadd	st,st		; 2*counter
				fmul	st,st(1)	; counter*2*amp
				fdiv	fPSW		; counter*2*amp/PSW-amp
				fsub	st,st(1)
				fstp	st(1)
		@@:
			fstp	real4 ptr [edi+ebx*4]
			mov	esi,[ecx].fre
			fadd	real4 ptr [esi+ebx*4]
			fst	[ecx].fCounter
			mov	eax,MIXING_FREQUENCY
			cmp	[ecx].fCounter,eax
			jc @f
				fsub	real4 ptr [ebp]
		@@:
			OSC_END
			ret
OSC_runPSAW		endp

OSC_runTRI		proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = 0.0;
;	smp = 2*amp*counter/sampleRate-amp
;	if ((counter += fre[i]) > sampleRate) counter -= sampleRate;
; }
;LOCAL dwPSW:dword
			OSC_BEGIN
			OSC_END
			ret
OSC_runTRI		endp

	assume ecx:nothing